_DPSettingsManager = {}

function _DPSettingsManager.changeQualityDisenchanting(quality, value)
	_G["DestroyusProItemQualityValue"][quality] = value
end

function _DPSettingsManager.changeQualityDisenchantingNumCommand(quality)
     local field = DestroyusProApi.numToStrQuality[DestroyusProApi.strToNumQuality[quality]]
	 if _G["DestroyusProItemQualityValue"][field] == DestroyusProApi.unknowNumber then
	    _G["DestroyusProItemQualityValue"][field] = DestroyusProApi.strToNumQuality[quality]
	 else
	    _G["DestroyusProItemQualityValue"][field] = DestroyusProApi.unknowNumber
	 end
end

function _DPSettingsManager.changeQualityDisenchantingStrCommand(quality)
    if _G["DestroyusProItemQualityValue"][quality] == DestroyusProApi.unknowNumber then
	   _G["DestroyusProItemQualityValue"][quality] = DestroyusProApi.strToNumQuality[quality]
	else  
	   _G["DestroyusProItemQualityValue"][quality] = DestroyusProApi.unknowNumber
	end
end

function _DPSettingsManager.unknownCommand(command)
    if command == nil then
		command = ""
	end
	local commandMsg = "Unknown value for the command: %s"
	print(commandMsg:format(command))
end

function _DPSettingsManager.createMacroDisenchanting()
	if GetMacroInfo("Disenchantus") == nil then
		CreateMacro("Disenchantus", "645142", "/click ClickMeForWorkDisenchanting")
	else
		print("Macro with the name 'Disenchantus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkDisenchanting")
	end
end

function _DPSettingsManager.createMacroMiling()
	if GetMacroInfo("Millingus") == nil then
		CreateMacro("Millingus", "237031", "/click ClickMeForWorkMilling")
	else
		print("Macro with the name 'Millingus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkMilling")
	end
end

function _DPSettingsManager.createMacroProspecting()
	if GetMacroInfo("Prospectingus") == nil then
		CreateMacro("Prospectingus", "133287", "/click ClickMeForWorkProspecting")
	else
		print("Macro with the name 'Prospectingus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkProspecting")
	end
end

function _DPSettingsManager.createMacroMassMilingLegion()
	if GetMacroInfo("MassMillingus") == nil then
		CreateMacro("MassMillingus", "237032", "/click ClickMeForWorkMassMillingLegion")
	else
		print("Macro with the name 'MassMillingus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkMassMillingLegion")
	end
end

function _DPSettingsManager.createMacroMassProspectingLegion()
	if GetMacroInfo("MassProspectingus") == nil then
		CreateMacro("MassProspectingus", "134119", "/click ClickMeForWorkMassProspectingLegion")
	else
		print("Macro with the name 'MassProspectingus' already exists. Check body macro if have same syntax: \n" ..
	      "/click ClickMeForWorkMassProspectingLegion")
	end
end

function _DPSettingsManager.changeStateForPrintout(msg)
	if msg == "offinfo" then
		_G["DestroyusProPrintOutState"] = false
	end
	if msg == "oninfo" then
		_G["DestroyusProPrintOutState"] = true
	end
end

-- Exist
function _DPSettingsManager.existMacro(macro_name)
	return GetMacroInfo(macro_name) ~= nil
end

-- Delete
function _DPSettingsManager.deleteMacro(macro_name)
	if _DPSettingsManager.existMacro(macro_name) then
		DeleteMacro(macro_name)
	else
		print("Macro does not exist or have different name than '"..macro_name.."'")
	end
end

function  _DPSettingsManager.openFrame(msg)
   if _DPMainSettingsFrame:IsVisible() then
       _DPMainSettingsFrame:Hide()
   else
       _DPMainSettingsFrame:Show()
   end
end