_DPSettingsManagerUI = {}

function _DPSettingsManagerUI.changeStatePrintout_OnClick(self, event)
	if self:GetChecked() then
	    _DPSettingsManager.changeStateForPrintout("offinfo")
	else
	    _DPSettingsManager.changeStateForPrintout("oninfo")
	end
end

function _DPSettingsManagerUI.MassProspectingLegion_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.createMacroMassProspectingLegion()
	else
	    _DPSettingsManager.deleteMacro("MassProspectingus")
	end
end

function _DPSettingsManagerUI.MassMilingLegion_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.createMacroMassMilingLegion()
	else
	    _DPSettingsManager.deleteMacro("MassMillingus")
	end
end

function _DPSettingsManagerUI.Prospecting_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.createMacroProspecting()
	else
	    _DPSettingsManager.deleteMacro("Prospectingus")
	end
end

function _DPSettingsManagerUI.Miling_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.createMacroMiling()
	else
	    _DPSettingsManager.deleteMacro("Millingus")
	end
end

function _DPSettingsManagerUI.Disenchanting_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.createMacroDisenchanting()
	else
	    _DPSettingsManager.deleteMacro("Disenchantus")
	end
end

function _DPSettingsManagerUI.Uncommon_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.changeQualityDisenchanting("uncommon",
		                   DestroyusProApi.strToNumQuality["uncommon"])
	else
	    _DPSettingsManager.changeQualityDisenchanting("uncommon",
		                   DestroyusProApi.unknowNumber)
	end
end

function _DPSettingsManagerUI.Rare_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.changeQualityDisenchanting("rare",
		                   DestroyusProApi.strToNumQuality["rare"])
	else
	    _DPSettingsManager.changeQualityDisenchanting("rare",
		                   DestroyusProApi.unknowNumber)
	end
end

function _DPSettingsManagerUI.Epic_OnClick(self, event)
    if self:GetChecked() then
        _DPSettingsManager.changeQualityDisenchanting("epic",
		                   DestroyusProApi.strToNumQuality["epic"])
	else
	    _DPSettingsManager.changeQualityDisenchanting("epic",
		                   DestroyusProApi.unknowNumber)
	end
end

function _DPSettingsManagerUI.OkayButton_OnClick(self, event)
	self:GetParent():Hide()
end

function _DPSettingsManagerUI.MainFrame_OnShow(self, event, arg1)	
	self._DPOptionFrame.panel.checkButtons["DisablePrintout"]:SetChecked(
	          not _G["DestroyusProPrintOutState"])	
    self._DPOptionFrame.panel.checkButtons["UncommonQualityS"]:SetChecked(
	          _G["DestroyusProItemQualityValue"]["uncommon"] ==
			  DestroyusProApi.strToNumQuality["uncommon"])
    self._DPOptionFrame.panel.checkButtons["RareQualityS"]:SetChecked(
	          _G["DestroyusProItemQualityValue"]["rare"] ==
			  DestroyusProApi.strToNumQuality["rare"])
    self._DPOptionFrame.panel.checkButtons["EpicQualityS"]:SetChecked(
	          _G["DestroyusProItemQualityValue"]["epic"] ==
			  DestroyusProApi.strToNumQuality["epic"])
end

function _DPSettingsManagerUI.MainFrame_MacroUpdate(self, event, arg1)
	self._DPOptionFrame.panel.checkButtons["MassProspectingus"]:SetChecked(
              _DPSettingsManager.existMacro("MassProspectingus"))
	self._DPOptionFrame.panel.checkButtons["Millingus"]:SetChecked(
              _DPSettingsManager.existMacro("Millingus"))
	self._DPOptionFrame.panel.checkButtons["Prospectingus"]:SetChecked(
              _DPSettingsManager.existMacro("Prospectingus"))
	self._DPOptionFrame.panel.checkButtons["MassMillingus"]:SetChecked(
              _DPSettingsManager.existMacro("MassMillingus"))
	self._DPOptionFrame.panel.checkButtons["Disenchantus"]:SetChecked(
              _DPSettingsManager.existMacro("Disenchantus"))
    
	-- If macro frame is visible. Check name of method if refresh will not work
	-- Check if MacroFrame is not nil. Bug reported by Niselma30
	-- This part of code always assume that MacroFrame exist.
	if DestroyusProMain.isInCombatMode == false then
	    if MacroFrame then
	        if MacroFrame:IsVisible() then
	            MacroFrame_Update()
            end
        end
    end
end